close all; clear; %clc;

dataPath = './Data/';
load(fullfile(dataPath,'baseSM12.mat'));
% load(fullfile(dataPath,'baseSM12_WeightedByVariance.mat'));

[dataNum,attributeNum] = size(baseSM12);

SM12 = baseSM12;
SM11 = zeros(dataNum);
SM22 = zeros(attributeNum);
W = [SM11,SM12;SM12.',SM22];
aoNum = size(W,1);
iM = eye(aoNum);
maxAbsEigs = max(abs(eigs(W)));

sfAddon = 1:5:41;
sfAddonNum = numel(sfAddon);

tList = 2:2:10;
tNum = numel(tList);

Affinity_VNK = cell(sfAddonNum,tNum+1);

for i = 1:sfAddonNum
    scaleFactor = maxAbsEigs + sfAddon(i);
    sW = W / (scaleFactor + eps);
    RWQ = inv(iM - sW);
    LAM = RWQ(1:dataNum,1:dataNum) .* (ones(dataNum) - eye(dataNum));
    Affinity_VNK{i,1} = LAM;
    maxT = max(tList);
    tmpA = sW;
    tIdx = 1;
    for j = 2:maxT
        tmpA = tmpA * sW + sW;
        if sum(tList == j) == 1
            thisLAM = tmpA(1:dataNum,1:dataNum) .* (ones(dataNum) - eye(dataNum));
            tIdx = tIdx + 1;
            Affinity_VNK{i,tIdx} = thisLAM;
        end
    end
end

save(fullfile(dataPath,'Affinity_VNK.mat'),'Affinity_VNK');