close all; clear; clc;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Load data
% dataPath = './Data/';
% 
% fid = fopen(fullfile(dataPath,'diagnosis.data'));
% C = textscan(fid,'%f %s %s %s %s %s %s %s','Delimiter','\t');
% fclose(fid);
% 
% save(fullfile(dataPath,'data.mat'),'C');
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Construct baseSM12
% addpath('..');
% dataPath = './Data/';
% load(fullfile(dataPath,'data.mat'));
% 
% sampleNum = 120;
% 
% baseSM12 = [];
% 
% thisAttribute = C{1};
% thisAffinity = ComputeAffinity4NumericAttribute(thisAttribute);
% baseSM12 = [baseSM12,thisAffinity];
% 
% for i = 2:6
%     thisAttribute = C{i};
%     thisAffinity = zeros(sampleNum,2);
%     for j = 1:sampleNum
%         if strcmp(thisAttribute{j},'yes')
%             thisAffinity(j,1) = 1;
%         else
%             thisAffinity(j,2) = 1;
%         end
%     end
%     baseSM12 = [baseSM12,thisAffinity];
% end
% 
% labelAttribute1 = C{7};
% labelAttribute2 = C{8};
% labelAffinity = zeros(sampleNum,4);
% ClassList = zeros(sampleNum,1);
% 
% for i = 1:sampleNum
%     if strcmp(labelAttribute1{i},'yes')
%         v1 = 1;
%     else
%         v1 = 0;
%     end
%     if strcmp(labelAttribute2{i},'yes')
%         v2 = 1;
%     else
%         v2 = 0;
%     end    
%     labelAffinity(i,v1*2+v2+1) = 1;
%     ClassList(i) = v1*2+v2+1;
% end
% 
% save(fullfile(dataPath,'baseSM12.mat'),'baseSM12');
% save(fullfile(dataPath,'ClassList.mat'),'ClassList');

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Construct 1-hot feature
dataPath = './Data/';
load(fullfile(dataPath,'data.mat'));

sampleNum = 120;
Feature_1hot = [];

thisAttribute = C{1};
Feature_1hot = [Feature_1hot,thisAttribute];

for i = 2:6
    thisAttribute = C{i};
    thisAffinity = zeros(sampleNum,2);
    for j = 1:sampleNum
        if strcmp(thisAttribute{j},'yes')
            thisAffinity(j,1) = 1;
        else
            thisAffinity(j,2) = 1;
        end
    end
    Feature_1hot = [Feature_1hot,thisAffinity];
end

save(fullfile(dataPath,'Feature_1hot.mat'),'Feature_1hot');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% dataPath = './Data/';
% 
% load(fullfile(dataPath,'data.mat'));
% 
% v1 = C{1};
% v2 = C{2};
% v3 = C{3};
% v4 = C{4};
% v5 = C{5};
% v6 = C{6};
% 
% Tbl = table(v1,v2,v3,v4,v5,v6);
% 
% save(fullfile(dataPath,'Tbl.mat'),'Tbl');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% addpath('..');
% dataPath = './Data/';
% load(fullfile(dataPath,'Tbl.mat'));
% 
% attributeIdx = 1:6;
% attributeDataType = [1,3,3,3,3,3];
% [DistanceMatrix,AffinityMatrix] = ComputeGowerCoefficient_Table...
%     (Tbl,attributeIdx,attributeDataType);
% save(fullfile(dataPath,'Gower.mat'),'DistanceMatrix','AffinityMatrix');

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %Prepare data for k-prototypes
% dataPath = './Data/';
% load(fullfile(dataPath,'Tbl.mat'));
% load(fullfile(dataPath,'ClassList.mat'));
% 
% dataNum = 120;
% 
% attributeDataType = [1,3,3,3,3,3];
% 
% nData = [];
% 
% for i = 1:6
%     thisAttr = Tbl.(i);
%     thisAttribute = zeros(dataNum,1);
%     if attributeDataType(i) == 1
%         validIndicator = (thisAttr ~= -1);
%         validAttribute = thisAttr(validIndicator);
%         minValue = min(validAttribute);
%         maxValue = max(validAttribute);
%         for j = 1:dataNum
%             if thisAttr(j) == -1
%                 thisAttribute(j) = -1;
%             else
%                 thisAttribute(j) = (thisAttr(j) - minValue) / (maxValue - minValue);
%             end            
%         end
%     else
%         validIndicator = ~strcmp(thisAttr,'-1');
%         uniqueValue = unique(thisAttr(validIndicator));
%         for j = 1:dataNum
%             if strcmp(thisAttr{j},'-1')
%                 thisAttribute(j) = -1;
%             else
%                 thisAttribute(j) = find(strcmp(uniqueValue,thisAttr{j}));
%             end            
%         end
%     end
%     nData = [nData,thisAttribute];
% end
%     
% save(fullfile(dataPath,'AcuteInflammations4KPrototype.mat'),...
%     'nData','attributeDataType','ClassList');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %Prepare data for k-means-mixed
% dataPath = './Data/';
% load(fullfile(dataPath,'Tbl.mat'));
% load(fullfile(dataPath,'ClassList.mat'));
% 
% dataNum = 120;
% 
% attributeDataType = [0,1,1,1,1,1];
% 
% nData = [];
% 
% for i = 1:6
%     thisAttr = Tbl.(i);
%     thisAttribute = zeros(dataNum,1);
%     if attributeDataType(i) == 0
%         validIndicator = (thisAttr ~= -1);
%         validAttribute = thisAttr(validIndicator);        
%         for j = 1:dataNum
%             if thisAttr(j) == -1
%                 thisAttribute(j) = -1;
%             else
%                 thisAttribute(j) = thisAttr(j);
%             end            
%         end
%     else
%         validIndicator = ~strcmp(thisAttr,'-1');
%         uniqueValue = unique(thisAttr(validIndicator));
%         for j = 1:dataNum
%             if strcmp(thisAttr{j},'-1')
%                 thisAttribute(j) = -1;
%             else
%                 thisAttribute(j) = find(strcmp(uniqueValue,thisAttr{j}));
%             end            
%         end
%     end
%     nData = [nData,thisAttribute];
% end
%     
% save(fullfile(dataPath,'AcuteInflammations4KMeansMixed.mat'),...
%     'nData','attributeDataType','ClassList');